## $Id: utils.py 15439 2019-05-29 12:07:27Z henrik $
##
## Copyright (C) 2012 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""Customize general helper utilities for Kofa.
"""
from copy import deepcopy
from kofacustom.nigeria.utils.utils import NigeriaKofaUtils

class CustomKofaUtils(NigeriaKofaUtils):
    """A collection of methods subject to customization.
    """

    COURSE_CATEGORY_DICT = {
        'C':'Core Course (C)',
        #'R':'Required Courses (R)',
        'E':'Elective Courses (E)',
        }

    APP_CATS_DICT = {
        'basic': 'UTME, DE, PCE',
        'no': 'No Application',
        'degree': 'Degree Programme',
        'nce': 'NCE Programme',
        'ncept': 'NCE Part-Time Programme',
        'nceptw': 'NCE Part-Time Weekend Programme',
        'prence': 'Pre-NCE Programme',
        'pdft':'Professional Diploma in Education',
        'pdpt':'Professional Diploma in Education Weekend',
        }

    STUDY_MODES_DICT = {
        'ug_ft': 'Undergraduate Full-Time',
        'de_ft': 'Direct Entry Full-Time',
        'pg_ft': 'Postgraduate Full-Time',
        'pg_pt': 'Postgraduate Part-Time',
        'nce_ft': 'NCE Full-Time',
        'nce_pt': 'NCE Part-Time',
        'nce_we_pt': 'NCE Part-Time Weekend',
        'nce_sw': 'NCE Sandwich',
        'prence': 'Pre-NCE',
        'no': 'no application',
        'pd_ft':'Professional Diploma in Education',
        'pd_pt':'Professional Diploma in Education Weekend',
        }

    PAYMENT_CATEGORIES = {
        'schoolfee': 'School Fee (total)',
        'schoolfee_1': 'School Fee (1st instalment)',
        'schoolfee_2': 'School Fee (2nd instalment)',
        'clearance': 'Acceptance Fee',
        #'bed_allocation': 'Bed Allocation Fee',
        #'hostel_maintenance': 'Hostel Maintenance Fee',
        #'transfer': 'Transfer Fee',
        #'gown': 'Gown Hire Fee',
        'application': 'Application Fee',
        #'transcript': 'Transcript Fee',
        #'late_registration': 'Late Course Registration Fee'
        }

    def selectable_payment_categories(self, student):
        return self.PAYMENT_CATEGORIES

    DISABLE_PAYMENT_GROUP_DICT = {
        'sf_all': 'School Fee - All Students',
        'degree': 'Degree Programme',
        }
